/*
 * JPA entity template
 *
 *
 * Takatuka - Template fuer JPA2 Entitaeten (inklusive Bean Validation)
 *
 * Moeglichkeiten und Einschraenkungen:
 * - Beziehungen werden abgebildet
 * -- es gibt keine 1:1 Beziehungen
 * -- N:M Beziehungen sind immer bidirektional
 * - Vererbung wird nicht unterstuetzt
 * - Support für CustomData
 */
package de.ivu.elect.business.wahlbeteiligung.entity;

@javax.persistence.NamedQueries(
 {



       @javax.persistence.NamedQuery(
     name="WAHLBETEILIGUNG_VERLAUF_GEBIET.UK",
     query="SELECT o FROM WahlbeteiligungVerlaufGebiet o WHERE "

                         + "o"
                +".gebiet"
                +".nummer"
              +" = ?1"

             +" AND "         + "o"
                +".gebiet"
                +".gebietsart"
                +".name"
              +" = ?2"

             +" AND "         + "o"
                +".gebiet"
                +".gebietsart"
                +".mandant"
                +".nummer"
              +" = ?3"

             +" AND "         + "o"
                +".gebiet"
                +".wahl"
                +".wahlart"
                +".name"
              +" = ?4"

             +" AND "         + "o"
                +".gebiet"
                +".wahl"
                +".wahlart"
                +".mandant"
                +".nummer"
              +" = ?5"

             +" AND "         + "o"
                +".gebiet"
                +".wahl"
                +".wahltermin"
                +".nummer"
              +" = ?6"

             +" AND "         + "o"
                +".gebiet"
                +".wahl"
                +".wahltermin"
                +".wahldatum"
              +" = ?7"

             +" AND "         + "o"
                +".gebiet"
                +".wahl"
                +".wahltermin"
                +".mandant"
                +".nummer"
              +" = ?8"

             +" AND "         + "o"
                +".gebiet"
                +".wahltermin"
                +".nummer"
              +" = ?9"

             +" AND "         + "o"
                +".gebiet"
                +".wahltermin"
                +".wahldatum"
              +" = ?10"

             +" AND "         + "o"
                +".gebiet"
                +".wahltermin"
                +".mandant"
                +".nummer"
              +" = ?11"

             +" AND "         + "o"
                +".wahlbeteiligungVerlauf"
                +".datum"
              +" = ?12"

             +" AND "         + "o"
                +".wahlbeteiligungVerlauf"
                +".name"
              +" = ?13"

             +" AND "         + "o"
                +".wahlbeteiligungVerlauf"
                +".wahl"
                +".wahlart"
                +".name"
              +" = ?14"

             +" AND "         + "o"
                +".wahlbeteiligungVerlauf"
                +".wahl"
                +".wahlart"
                +".mandant"
                +".nummer"
              +" = ?15"

             +" AND "         + "o"
                +".wahlbeteiligungVerlauf"
                +".wahl"
                +".wahltermin"
                +".nummer"
              +" = ?16"

             +" AND "         + "o"
                +".wahlbeteiligungVerlauf"
                +".wahl"
                +".wahltermin"
                +".wahldatum"
              +" = ?17"

             +" AND "         + "o"
                +".wahlbeteiligungVerlauf"
                +".wahl"
                +".wahltermin"
                +".mandant"
                +".nummer"
              +" = ?18"

     ,
   hints = {
             @javax.persistence.QueryHint(name = "org.hibernate.flushMode", value = "commit")
   }


   )
   
 }
)
@javax.enterprise.inject.Vetoed
@javax.persistence.Entity
@javax.persistence.Table(name = "WAHLBETEILIGUNG_VERLAUF_GEBIET")
// @javax.persistence.IdClass(WahlbeteiligungVerlaufGebietPK.class)
    @javax.persistence.EntityListeners(de.ivu.elect.jee.protokollierung.ProtokollEntityListener.class)
    
public
 class WahlbeteiligungVerlaufGebiet
extends AbstractWahlbeteiligungVerlaufGebiet
  {

  private static final long serialVersionUID = 0L;


  /**
   * default constructor
   */
  public WahlbeteiligungVerlaufGebiet() {
    super();
  }

    /**
     * @param original
     *
     * @deprecated Sollte nur mit Bedacht genutzt werden, da hier auch die Beziehungen kopiert werden. Deswegen markiert
     *             als Deprecated.
     */
    @Deprecated
    public WahlbeteiligungVerlaufGebiet(WahlbeteiligungVerlaufGebiet original){
      original.copyEntity(this);
    }

  /**
   * PRIMARY KEY
   */
  @javax.persistence.Id
  @javax.persistence.Column(name = "wahlbeteiligung_verlauf_geb_id")
    @javax.persistence.GeneratedValue(strategy = javax.persistence.GenerationType.TABLE, generator = "WahlbeteiligungVerlaufGebiet")
    @javax.persistence.TableGenerator(name = "WahlbeteiligungVerlaufGebiet", table = "SEQUENCES", pkColumnName = "sequence_name", pkColumnValue = "WahlbeteiligungVerlaufGebiet", valueColumnName = "next_val", allocationSize = 1000, initialValue = 0)
    protected java.lang.Long id;

  @Override
  public java.lang.Long getId() {
    return id;
  }

  public void setId(java.lang.Long id) {
    this.id = id;
  }

  @javax.persistence.Transient
  private transient WahlbeteiligungVerlaufGebietPK pkCache;

  @Override
  public WahlbeteiligungVerlaufGebietPK getPk() {
    if (pkCache==null || pkCache.getId() != id ) {
      pkCache = new WahlbeteiligungVerlaufGebietPK(getId());
    }

    return pkCache;
  }

  public static <E extends WahlbeteiligungVerlaufGebiet> java.util.Map<WahlbeteiligungVerlaufGebietPK, E> mappeNachPk(java.util.Collection<E> entities){
    java.util.Map<WahlbeteiligungVerlaufGebietPK, E> result = new java.util.HashMap<>();

    for (E entity : entities) {
      result.put(entity.getPk(), entity);
    }

    return result;
  }

  public static <E extends WahlbeteiligungVerlaufGebiet> java.util.Map<Long, E> mappeNachId(java.util.Collection<E> entities){
    java.util.Map<Long, E> result = new java.util.HashMap<>();

    for (E entity : entities) {
      result.put(entity.getId(), entity);
    }

    return result;
  }



  /**
   * Indikator, ob sich ein Attribut oder eine UNIDIREKTIONALE n:1-Beziehungen geaendert hat
   */
  @javax.persistence.Transient
  protected boolean attributeChanged = false;

  public void setAttributeChanged() {
    attributeChanged = true;
  }

  public boolean isAttributeChanged() {
    return attributeChanged;
  }

  /**
   * Hilfsvariable fuer das Aktualisieren von Beziehungen
   */
  @javax.persistence.Transient
  protected boolean updateRelationship = false;


  public void resetAttributeChanged() {
        hasChangedWahlbeteilung = false;
  
      hasChangedGebiet = false;
    


    attributeChanged = false;
  }


  /**
   * ATTRIBUTE
   */

    
  @javax.persistence.Column(name = "WAHLBETEILUNG", nullable = WahlbeteiligungVerlaufGebietConstants.WAHLBETEILUNG_NULLABLE, precision=WahlbeteiligungVerlaufGebietConstants.WAHLBETEILUNG_PRECISION, scale=WahlbeteiligungVerlaufGebietConstants.WAHLBETEILUNG_SCALE)
            
  protected java.math.BigDecimal wahlbeteilung =  null;

  @javax.persistence.Transient
  protected boolean hasChangedWahlbeteilung = false;

  public boolean hasChangedWahlbeteilung(){
    return hasChangedWahlbeteilung;
  }
       @javax.persistence.Transient
     private transient boolean isSeitLadenVeraendertWahlbeteilung = false;
     @javax.persistence.Transient
     private transient java.math.BigDecimal wertNachLadenWahlbeteilung;
  
  /**
   * 
   *
   * getter for WAHLBETEILIGUNG_VERLAUF_GEBIET.WAHLBETEILUNG
   */
  @javax.annotation.Nullable   @Override   public  java.math.BigDecimal getWahlbeteilung() {
        return wahlbeteilung;
      }

  /**
   * 
   *
   * setter for WAHLBETEILIGUNG_VERLAUF_GEBIET.WAHLBETEILUNG
   *
   * @param wahlbeteilung
   */
  @Override   public void setWahlbeteilung(@javax.annotation.Nullable  java.math.BigDecimal wahlbeteilung) {

       resetTkCache();
                  java.math.BigDecimal wahlbeteilungInternal = wahlbeteilung;
       
       
      boolean thisAttributChanged =
      !de.ivu.elect.jee.entity.EntityUtil.compareObjects(this.wahlbeteilung
      , wahlbeteilungInternal);

      attributeChanged |= thisAttributChanged;

      hasChangedWahlbeteilung |= thisAttributChanged;

      if (thisAttributChanged) {
      markDirty("wahlbeteilung");
      }


             if (!isSeitLadenVeraendertWahlbeteilung) {
          isSeitLadenVeraendertWahlbeteilung = thisAttributChanged;
         if (isSeitLadenVeraendertWahlbeteilung){
           wertNachLadenWahlbeteilung=this.wahlbeteilung;
         }
       }
      

       this.wahlbeteilung = wahlbeteilungInternal;

         }

    
/**
 * Beziehungen N:1 unidirektional
 */
  /**
   * Beziehung (unidirektional) zu Gebiet
   */
  @javax.persistence.ManyToOne(fetch =  javax.persistence.FetchType.LAZY , optional=false, cascade = {javax.persistence.CascadeType.PERSIST})
  @javax.persistence.JoinColumns(@javax.persistence.JoinColumn(name = "GEBIET_ID", referencedColumnName="GEBIET_ID"))
  protected de.ivu.elect.business.gebietsbaum.entity.Gebiet gebiet;

  /**
   * 
   */
  @Override
  public void setGebiet( de.ivu.elect.business.gebietsbaum.entity.Gebiet gebiet){
    resetTkCache();
    
    boolean thisAttributChanged =
    !de.ivu.elect.jee.entity.EntityUtil.compareObjects(this.gebiet
    , gebiet);

    attributeChanged |= thisAttributChanged;

    hasChangedGebiet |= thisAttributChanged;

    if (thisAttributChanged) {
    markDirty("gebiet");
    }

    this.gebiet = gebiet;
      }

  /**
   * 
   */
    @Override
  public de.ivu.elect.business.gebietsbaum.entity.Gebiet getGebiet(){
    return this.gebiet;
  }

  @javax.persistence.Transient
  protected boolean hasChangedGebiet = false;

  public boolean hasChangedGebiet(){
    return hasChangedGebiet;
  }


/**
 * Beziehungen N:1 bidirektional
 */
  /**
   * Beziehung N:1 (bidirektional) zu WahlbeteiligungVerlauf
   */
  @javax.persistence.ManyToOne(fetch =  javax.persistence.FetchType.LAZY , optional=false, cascade = {javax.persistence.CascadeType.PERSIST})
  @javax.persistence.JoinColumns(@javax.persistence.JoinColumn(name = "WAHLBETEILIGUNG_VERLAUF_ID", referencedColumnName="WAHLBETEILIGUNG_VERLAUF_ID"))
  protected de.ivu.elect.business.wahlbeteiligung.entity.WahlbeteiligungVerlauf wahlbeteiligungVerlauf;

  /**
   * 
   */
  @Override
  public void setWahlbeteiligungVerlauf( de.ivu.elect.business.wahlbeteiligung.entity.WahlbeteiligungVerlauf wahlbeteiligungVerlauf){
    resetTkCache();

    try {
      if (!updateRelationship){
        updateRelationship = true;

    

        if (wahlbeteiligungVerlauf == null){
          // andere Seite der Beziehung aktualisieren wenn vorher nicht null
          if (this.wahlbeteiligungVerlauf != null){
            this.wahlbeteiligungVerlauf.removeWahlbeteiligungVerlaufGebietByWahlbeteiligungVerlauf(this);
          }
        } else {
          // andere Seite der Beziehung aktualisieren
          wahlbeteiligungVerlauf.addWahlbeteiligungVerlaufGebietByWahlbeteiligungVerlauf(this);
        }
        this.wahlbeteiligungVerlauf = wahlbeteiligungVerlauf;
    
      }
    } finally {
      updateRelationship = false;
    }
  }


/**
* 
* Kein Update der bidirektionalen Beziehung - schneller, aber mit Vorsicht zu genießen
*/
@Override
public void setWahlbeteiligungVerlaufOhneUpdateBeziehung( de.ivu.elect.business.wahlbeteiligung.entity.WahlbeteiligungVerlauf wahlbeteiligungVerlauf){
    resetTkCache();
        this.wahlbeteiligungVerlauf = wahlbeteiligungVerlauf;
    }

  /**
   * 
   */
    @Override
  public de.ivu.elect.business.wahlbeteiligung.entity.WahlbeteiligungVerlauf getWahlbeteiligungVerlauf(){
    return this.wahlbeteiligungVerlauf;
  }


  /**
   * Beziehungen 1:N unidirektional (nicht unterstuetzt)
   */

  /**
   * Beziehungen 1:N bidirektional
   */

  /**
   * Beziehungen N:M bidirektional nicht selbstreferenzierend
   */


  /**
   * Beziehungen N:M bidirektional selbstreferenzierend
   */
  

  @Override
  public String toString() {
    StringBuilder sb = new StringBuilder();
    sb.append("WahlbeteiligungVerlaufGebiet:");
    sb.append(getId());
    sb.append(" (TK: ");
    try {
      sb.append(getTk());
    } catch (Exception e) {
      sb.append(e.getMessage());
    }
    sb.append(")");
    return sb.toString();
}



  /**
   * Kopiert alle Attribute (ausser PK und Version) und UNIDIREKTIONALE n:1-Beziehungen in uebergebene Entitaet.
   *
   * @param other
   *
   * @deprecated Sollte nur mit Bedacht genutzt werden, da hier auch die Beziehungen kopiert werden. Deswegen markiert
   *             als Deprecated.
   */
  @Deprecated
  protected void copyEntity(WahlbeteiligungVerlaufGebiet other){
                             other.wahlbeteilung = this.wahlbeteilung;
           
  other.setGebiet(this.getGebiet());
  other.setWahlbeteiligungVerlauf(this.getWahlbeteiligungVerlauf());
    if (this.transientContext != null && !this.transientContext.isEmpty()) {
      other.getTransientContext().putAll(this.transientContext);
    }
  }



    @Override
    public void copyEntityAttributesToOtherEntity(de.ivu.elect.jee.entity.Entity other) {
      if (other==null){
        return;
      }
      if (other.isInstanceOf(WahlbeteiligungVerlaufGebiet.class)){
        copyEntityAttributesUsingSetter((WahlbeteiligungVerlaufGebiet) other.castTo(WahlbeteiligungVerlaufGebiet.class).getEntity());
      } else {
        throw new IllegalArgumentException("Keine Instanz von WahlbeteiligungVerlaufGebiet: " + other);
      }
    }

  /**
  * Kopiert alle Attribute (ausser PK und Version)  in uebergebene Entitaet.
  *
  */
  public void copyEntityAttributesUsingSetter(WahlbeteiligungVerlaufGebiet other){
               other.setWahlbeteilung(this.wahlbeteilung);
           if (this.transientContext != null && !this.transientContext.isEmpty()) {
      other.getTransientContext().putAll(this.transientContext);
    }
  }


  /**
   * Kopiert alle veränderten Attribute (ausser PK, CustomData, wenn vorhanden und Version) in uebergebene Entitaet.
   *
   */
  public void copyChangedEntityAttributesUsingSetter(WahlbeteiligungVerlaufGebiet other){
                       if (hasChangedWahlbeteilung) {
        other.setWahlbeteilung(this.wahlbeteilung);
      }
             }





    @javax.persistence.Transient
    private transient WahlbeteiligungVerlaufGebietTK tkCache;

    protected void resetTkCache() {
        tkCache = null;
    }

    public WahlbeteiligungVerlaufGebietTK getWahlbeteiligungVerlaufGebietTK(){
    if (tkCache==null) {
    tkCache = new WahlbeteiligungVerlaufGebietTK(

  (getGebiet() == null) ? null : getGebiet().getGebietTK()
,   (getWahlbeteiligungVerlauf() == null) ? null : getWahlbeteiligungVerlauf().getWahlbeteiligungVerlaufTK()


  );}
  return tkCache;
}
    @Override
    public de.ivu.elect.jee.entity.tk.EntityTK getTk() {
       return getWahlbeteiligungVerlaufGebietTK();
    }

  @Override
  public WahlbeteiligungVerlaufGebietUK getUk(){
    return getWahlbeteiligungVerlaufGebietUK();
  }

  @Override
  public Class< ? > getEntityClass() {
    return WahlbeteiligungVerlaufGebiet.class;
  }

public WahlbeteiligungVerlaufGebietUK getWahlbeteiligungVerlaufGebietUK(){

   return  new WahlbeteiligungVerlaufGebietUK(

    getGebiet()==null?null:getGebiet().getGebietUK()
,     getWahlbeteiligungVerlauf()==null?null:getWahlbeteiligungVerlauf().getWahlbeteiligungVerlaufUK()


  );
}

  @javax.persistence.Transient
  private transient WahlbeteiligungVerlaufGebietProperties properties;

  public WahlbeteiligungVerlaufGebietProperties getProperties(){
    if (properties == null) {
      properties = new WahlbeteiligungVerlaufGebietProperties(this);
    }
    return properties;
  }

  /**
   * @deprecated getProperties() verwenden.
   */
  @Deprecated
  public WahlbeteiligungVerlaufGebietProperties getWahlbeteiligungVerlaufGebietProperties(){
    return getProperties();
  }

  @Override
  public String getEntityTechnicalName() {
    return WahlbeteiligungVerlaufGebietConstants.MESSAGE_KEY_ENTITY_EINZAHL;
  }

  @Override
  public boolean isAenderungenProtokollieren(){
    
    return true;
  }


    @Override
   public void setProtokollierteAttributeMitWerten(java.util.Map<String, de.ivu.elect.jee.protokollierung.AttributWertVorher> werteVorher) {
     
      if (werteVorher.containsKey(WahlbeteiligungVerlaufGebietConstants.MESSAGE_KEY_WAHLBETEILUNG_EINZAHL)){
        de.ivu.elect.jee.protokollierung.AttributWertVorher vorher = werteVorher.get(WahlbeteiligungVerlaufGebietConstants.MESSAGE_KEY_WAHLBETEILUNG_EINZAHL);

        wahlbeteilung =
                        vorher.getAttributTyp().getValueAsBigDecimal(vorher.getWertVorher());
                  }

                }

  @Override
  public java.util.Map<String, de.ivu.elect.jee.protokollierung.VorherNachherWert> getProtokollierteAttributeMitWerten() {
    java.util.Map<String,de.ivu.elect.jee.protokollierung.VorherNachherWert> result;
        result = createEmptyProtokollierteAttributeMitWertenMap();
                        if (isSeitLadenVeraendertWahlbeteilung) {
      result.put(WahlbeteiligungVerlaufGebietConstants.MESSAGE_KEY_WAHLBETEILUNG_EINZAHL, new de.ivu.elect.jee.protokollierung.VorherNachherWert(
                                    de.ivu.elect.jee.protokollierung.AttributTyp.BIG_DECIMAL
                            , wertNachLadenWahlbeteilung , wahlbeteilung));
    }
                return result;
  }

  @Override
  public void resetProtokollierteAttribute() {
                      isSeitLadenVeraendertWahlbeteilung = false;
      wertNachLadenWahlbeteilung = null;
                   }

  @Override
  public  java.util.List<de.ivu.elect.jee.entity.EntityFachlichAbhaengigNode> getFachlichAbhaengigeEntitaeten(){
            java.util.List<de.ivu.elect.jee.entity.EntityFachlichAbhaengigNode> result = new java.util.ArrayList<>();
                            return result;
  }

        
            protected String getInitialDiscriminator() {
              return "WAHLBETEILIGUNG_VERLAUF_GEBIET";
            }

            @Override
            public boolean isInstanceOf(Class<?> clazz) {
            return clazz.isInstance(this);
            }


            @Override
            public <E> de.ivu.elect.jee.entity.EntityContainer<E> castTo(Class<E> clazz) {
                return new de.ivu.elect.jee.entity.EntityContainer<>((E)this); // EntityContainer ist notwendig, da sonst von Hibernate die Entität wieder durch ihren Proxy ersetzt wird...
            }

  public boolean isPersistent() {
    return getId() != null;
  }


   private static final String BASE_CLASS_NAME = "WahlbeteiligungVerlaufGebiet";
   @Override
   public String getBaseClassName() {
     return BASE_CLASS_NAME;
   }


    @Override
    public boolean equals(Object obj) {
    if (obj == null) {
    return false;
    }

    if (this==obj) {
    return true;
    }


    if (id != null) {
      try {
        return id.longValue() == ((de.ivu.elect.jee.entity.Entity) obj).getId().longValue() && BASE_CLASS_NAME.equals(((de.ivu.elect.jee.entity.Entity) obj).getBaseClassName());
      } catch (Exception ignored) {
        // do nothing
        return false;
      }
    }
   return super.equals(obj);
    }

  @javax.persistence.Transient
  private transient boolean hashCodeBerechnet = false;

  @javax.persistence.Transient
  private transient int hashCode = 0;


  @Deprecated // nur in Unit-Tests verwenden(!)
  public void resetHashCode() {
    hashCodeBerechnet = false;
    hashCode = 0;
  }

  @Override
    public int hashCode() {
      if (hashCodeBerechnet) {
      return hashCode;
    }

    if (id == null) {
      hashCode = super.hashCode();
    } else {
      hashCode = id.hashCode();
    }

    hashCodeBerechnet = true;

    return hashCode;

    }


                            @javax.persistence.Transient
                private transient java.util.Set
            <String> dirtyProperties = null;

                protected void markDirty(String property) {
            
          }

          public java.util.Set
      <String> getDirtyProperties() {
          if (dirtyProperties==null){
          dirtyProperties = new java.util.HashSet<>();
          }
          return dirtyProperties;
          }

          public void clearDirtyProperties(){
          dirtyProperties = null;
          }
          public boolean isHibernateDirty() {
            return dirtyProperties!=null;
          }

      
                public void resetValidation() {
        
    validationResult = null;
        }

        @javax.persistence.Transient
        private transient java.util.Set<de.ivu.elect.jee.entity.EntityConstraintViolation> validationResult;

                    public java.util.Set<de.ivu.elect.jee.entity.EntityConstraintViolation> validateEntity() {
            if (validationResult==null) {
               validationResult  = new java.util.HashSet<>();
                                                                                                           de.ivu.elect.jee.entity.EntityConstraintCheck.checkValueRange(WahlbeteiligungVerlaufGebietConstants.WAHLBETEILUNG_MAX_VALUE, WahlbeteiligungVerlaufGebietConstants.WAHLBETEILUNG_MIN_VALUE, wahlbeteilung, this, WahlbeteiligungVerlaufGebietConstants.MESSAGE_KEY_WAHLBETEILUNG_EINZAHL, validationResult);
                                    }
             return validationResult;
        }

            
        @javax.persistence.Transient
        protected transient java.util.Map<String, Object> transientContext;

        @Override
        public java.util.Map<String, Object> getTransientContext() {
          if (transientContext == null) {
             transientContext = new java.util.HashMap<>();
          }
        return transientContext;

        }
                              }
